'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _state = require('./state');

var _state2 = _interopRequireDefault(_state);

var _throwError = require('./throw-error');

var _throwError2 = _interopRequireDefault(_throwError);

exports['default'] = function (matchersFactories) {
    return function (Component) {
        return (function (_React$Component) {
            _inherits(DataFetcher, _React$Component);

            _createClass(DataFetcher, null, [{
                key: 'contextTypes',
                value: {
                    state: _react2['default'].PropTypes.instanceOf(_state2['default'])
                },
                enumerable: true
            }]);

            function DataFetcher(props, context) {
                _classCallCheck(this, DataFetcher);

                _get(Object.getPrototypeOf(DataFetcher.prototype), 'constructor', this).call(this, props, context);

                this.dataState = context.state;

                if (typeof this.dataState === 'undefined') {
                    (0, _throwError2['default'])('missing state. It can happen if you forgot to set state in DataInit\n                        or using any decorator before DataInit', this.constructor.displayName);
                }
            }

            _createClass(DataFetcher, [{
                key: 'componentDidMount',
                value: function componentDidMount() {
                    this.dataState._registerFetcher(matchersFactories);
                }
            }, {
                key: 'componentWillUnmount',
                value: function componentWillUnmount() {
                    this.dataState._unregisterFetcher(matchersFactories);
                }
            }, {
                key: 'render',
                value: function render() {
                    return _react2['default'].createElement(Component, this.props, this.props.children);
                }
            }]);

            return DataFetcher;
        })(_react2['default'].Component);
    };
};

module.exports = exports['default'];